import java.net.*;
import org.w3c.dom.*;
import oracle.xml.parser.v2.*;

public class Customer extends Thread {

  URL xslURL;
  XMLDocument xmldoc, styledoc;
  XSLStylesheet xsldoc;
  XMLDocumentFragment result;
  DOMParser    parser ;
  XSLProcessor processor;
  Response[] response;

  public Customer()  {
     init();
  }

// Chargement du document XML et de la feuille XSL

  public void init() {
     try {
       parser = new DOMParser();
       processor = new XSLProcessor();
       parser.parse(new URL("file:///e:/scenariotest/dept.xml"));
       xmldoc = parser.getDocument();

       xslURL = new URL("file:///e:/coface/scenariotest/dept.xsl");
       parser.parse(xslURL);
       xsldoc = new XSLStylesheet(parser.getDocument(), xslURL);
     } catch(Exception e) {

     }
  }

  public void run() {
     long begin, end;
     int nb = 300;		// nbre de fois quest invoque la requte par client
     response = new Response[nb];

     for (int i=0; i<nb; i++) {

      begin = System.currentTimeMillis();
      test();
      end = System.currentTimeMillis();

      response[i] = new Response();
      response[i].ident    = i;
      response[i].duration = end - begin;

      try {
        sleep(0);
      } catch (InterruptedException e) { System.out.println("Abandon"); }

     }

  }

  public long getTime() {
    long total = 0;
    for (int i=0; i<response.length; i++) {
         total += response[i].duration;
    }
    return total;
  }

  public int getOccurence() {
    return response.length;
  }

// opration de transformation invoque  chaque requte

  public void test() {
     try {
       result = processor.processXSL(xsldoc, xmldoc);
     } catch(Exception e) {}
  }

  public void init(String scenariofile, long time) {
  }

}
